'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _convert = require('./convert');

var _VariableNode = require('./VariableNode');

var _VariableNode2 = _interopRequireDefault(_VariableNode);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Condition = function () {
    function Condition(op, l, r, i, negate) {
        _classCallCheck(this, Condition);

        this.op = op.trim();
        this.lvalue = l;
        this.rvalue = r;
        this._index = i;
        this.negate = negate;
    }

    _createClass(Condition, [{
        key: 'accept',
        value: function accept(visitor) {
            this.lvalue = visitor.visit(this.lvalue);
            this.rvalue = visitor.visit(this.rvalue);
        }
    }, {
        key: 'eval',
        value: function _eval(context) {
            var a = this.lvalue.eval(context);
            var b = this.rvalue.eval(context);
            a = a.value ? a.value : (0, _convert.convertNode)(a);
            b = b.value ? b.value : (0, _convert.convertNode)(b);
            var result = void 0;
            switch (this.op) {
                case 'and':
                    result = a + ' && ' + b;
                    break;
                case 'or':
                    result = a + ' || ' + b;
                    break;
                case '=':
                    result = a + ' == ' + b;
                    break;
                default:
                    result = a + ' ' + this.op + ' ' + b;
                    break;
            }

            if (this.negate) {
                return new _VariableNode2.default('!' + result);
            } else {
                return new _VariableNode2.default(result);
            }
        }
    }]);

    return Condition;
}();

exports.default = Condition;